/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices;

import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Scanner;
import review.business.*;

/**
 *
 * @author kirsch
 */
public class DepartmentTest1 {

    Department dept;

    public DepartmentTest1(String name) {
        this.dept = new Department(name);
    }

    public DepartmentTest1() {
        this.dept = new Department();
    }

    /**
     * creer un nouveau employee et l'additionne au departement
     */
    public void newEmployee () {
        Employee e = new Employee();
        readEmployee(e);
        this.dept.addEmployee(e);
    }


    public void newManager () {
        Manager m = new Manager();
        readManager(m);
        this.dept.addEmployee(m);
        this.dept.setManager(m);
    }


    protected void readManager (Manager m) {
        Scanner in = new Scanner(System.in);
        readEmployee(m);
        System.out.print ("Bonus: ");
        if (in.hasNextFloat()) m.setBonus(in.nextFloat());
    }


    protected void readEmployee (Employee e) {
        Scanner in = new Scanner(System.in);
        System.out.print ("Name: ");
        if (in.hasNextLine()) e.setName(in.next());
        System.out.print("Salary: ");
        if (in.hasNextFloat()) e.setSalary(in.nextFloat());
        e.setHireDay(readDate(in));
    }

    protected Date readDate(Scanner in) {
        int day, month, year;

        System.out.print("Hire year: ");
        year = in.nextInt();
        System.out.print("Hire month (1-12): ");
        month = in.nextInt();
        System.out.print("Hire day: ");
        day = in.nextInt();

        Calendar cal = Calendar.getInstance();
        cal.set(year, (month-1), day);

        return cal.getTime();
    }

    
    /**
     * augmente tous les salaires
     */
    public void raiseSalary () {
        float perc = this.readPercentual();
        this.dept.raiseAllSalaries(perc);
    }


    protected float readPercentual () {
        Scanner in = new Scanner(System.in);
        System.out.print("Raise up percentual (0,xx): ");
        float perc = in.nextFloat();
        return perc;
    }


    /** 
     * affiche les informations concernant le departement, ainsi que sees membres
     */
    public void print () {
        System.out.println("Dept "+this.dept.getName());
        System.out.println("Manager ");
        this.printManager(this.dept.getManager());

        System.out.println("Employees ");
        Iterator<Employee> membres = this.dept.employees();
        while (membres.hasNext()) {
            this.printEmployee(membres.next());
        }
    }


    protected void printEmployee (Employee e) {
        System.out.println("Name: " + e.getName());
        System.out.println("Salary: " + e.getSalary());
        System.out.println("Hire date: " + e.getHireDay());
    }

    protected void printManager (Manager m) {
        printEmployee(m);
        System.out.println("Bonus: " + m.getBonus());
    }

    
    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        DepartmentTest1 test = new DepartmentTest1("Testing Dept");

        test.newEmployee();
        test.newManager();
        test.raiseSalary();
        test.print();
    }

}
