/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices;

import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.FileReader;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.PrintWriter;
import java.util.Iterator;
import java.util.Scanner;
import java.util.logging.Level;
import java.util.logging.Logger;
import review.business.Department;
import review.business.Employee;

/**
 *
 * @author kirsch
 */
public class DepartmentTest3 extends DepartmentTest1 {

    public void print(Department d) {
        System.out.println("Dept "+d.getName());
        System.out.println("Manager ");
        this.printManager(d.getManager());

        System.out.println("Employees ");
        Iterator<Employee> membres = d.employees();
        while (membres.hasNext()) {
            this.printEmployee(membres.next());
        }
    }

    public void write () {
        try {
            PrintWriter out = new PrintWriter("DepartmentTest3.txt");

            Iterator<Employee> employees = this.dept.employees();
            while (employees.hasNext()) {
                Employee e = employees.next();
                out.println(e.getName());
            }

            out.flush();
            out.close();
        } catch (IOException ex) {
            System.out.println("Fichier impossible a creer");
            Logger.getLogger(DepartmentTest3.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void read () {
        try {
            FileReader reader = new FileReader("DepartmentTest3.txt");
            Scanner in = new Scanner(reader);
            while (in.hasNext()) {
                String line = in.nextLine();
                System.out.println (line);
            }
            reader.close();
        } catch (FileNotFoundException ex) {
            System.out.println("Fichier impossible a lire");
            Logger.getLogger(DepartmentTest3.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            System.out.println("Erreur de lecture dans le fichier ");
            Logger.getLogger(DepartmentTest3.class.getName()).log(Level.SEVERE, null, ex);
        }
    }


    public void load() {
        ObjectInputStream in;
        try {
            in = new ObjectInputStream(new FileInputStream("DepartmentTest3.dat"));
            Department d = (Department) in.readObject();
            print(d);
        } catch (ClassNotFoundException ex) {
            Logger.getLogger(DepartmentTest3.class.getName()).log(Level.SEVERE, null, ex);
        } catch (IOException ex) {
            Logger.getLogger(DepartmentTest3.class.getName()).log(Level.SEVERE, null, ex);
        }
    }

    public void save () {
        ObjectOutputStream out;
        try {
            out = new ObjectOutputStream(new FileOutputStream("DepartmentTest3.dat"));
            out.writeObject(this.dept);
        } catch (IOException ex) {
            Logger.getLogger(DepartmentTest3.class.getName()).log(Level.SEVERE, null, ex);
        }
    }



     public static void main(String[] args) {
        DepartmentTest3 test = new DepartmentTest3();

        test.newEmployee();
        test.newManager();
        test.raiseSalary();
        test.print();

        test.write();
        test.read();

        test.save();
        test.load();
    }
}