/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 */

package review.exercices.business;

import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import review.business.Employee;

/**
 *
 * @author kirsch
 */
public class ConcreteDepartmentControler implements DepartmentControler {

    private ArrayList<DepartmentView> views;

    private DepartmentModel model;

    public ConcreteDepartmentControler(DepartmentModel model) {
        this.model = model;
        this.views = new ArrayList<DepartmentView>();
    }


    public void notifyAddEmployee(String name, float salary, Date hire) {
        Employee newE = new Employee (name, salary, hire);
        this.model.addEmployee(newE);
    }

    public void notifyRemoveEmployee(String name) {
        Employee supE = this.model.getEmployee(name);
        if (supE != null)
            this.model.removeEmployee(supE);
        /* else {
         * //ICI ON DEVAIT LANCE UNE EXCEPTION AFIN QUE L'INTERFACE GRAPHIQUE
         * //PUISSE AFFICHER LE MESSAGE D'ERREUR APPROPRIE
         * */
    }

    public List getEmployeeNames() {
        ArrayList<String> eNames = new ArrayList();
        Iterator<Employee> iter = this.model.employees();
        while (iter.hasNext())
            eNames.add(iter.next().getName());

        return eNames;
    }

    public void addDepartmentView(DepartmentView view) {
        this.views.add(view);
        this.model.addDepartmentListner(view);
    }

    public void removeDepartmentView(DepartmentView view) {
        this.model.removeDepartmentListener(view);
        this.views.remove(view);
    }

    public void diplayAll() {
        for (DepartmentView v: this.views) {
            v.setVisible(true);
        }
    }

    public void closeAll() {
        this.model.save();
        System.exit(0);
    }

}
