/*
UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
MIAGE - UFR 27
Cours ISI5 / INF2 - Developpement d'Interface
 */
package review.ihmexamples;

import java.awt.GridLayout;
import java.util.Calendar;
import java.util.Date;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSpinner;
import javax.swing.SpinnerDateModel;
import javax.swing.SpinnerNumberModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

/**
 *
 * @author kirsch
 */
public class ListModelDemo implements ChangeListener {

    JFrame frame;
    JList list;
    DefaultListModel lmodel;
    JSpinner numSpinner, dateSpinner;
    SpinnerDateModel datemodel;
    SpinnerNumberModel nummodel;
    String last = "";

    public ListModelDemo() {
        prepareList();
        prepareSpinner();
        prepareFrame();
    }

    private void prepareList() {
        this.lmodel = new DefaultListModel();
        this.lmodel.addElement(new Integer(0));
        this.list = new JList(this.lmodel);
    }

    
    private void prepareSpinner() {
        this.nummodel = new SpinnerNumberModel();
        this.numSpinner = new JSpinner(this.nummodel);

        this.datemodel = new SpinnerDateModel(Calendar.getInstance().getTime(),
                null, null, Calendar.DAY_OF_MONTH);
        this.dateSpinner = new JSpinner(this.datemodel);
        this.dateSpinner.setEditor(new JSpinner.DateEditor(this.dateSpinner, "MM/yyyy"));

        this.numSpinner.addChangeListener(this);
        this.dateSpinner.addChangeListener(this);
    }

    private void prepareFrame() {
        this.frame = new JFrame("Swing Models Demo");
        this.frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        this.frame.setLayout(new GridLayout(1, 2));

        JScrollPane scroll = new JScrollPane(this.list);
        this.frame.add(scroll);

        JPanel panel = new JPanel();
        panel.setLayout(new GridLayout(3, 1));
        panel.add(new JLabel("Values"));
        panel.add(this.numSpinner);
        panel.add(this.dateSpinner);
        this.frame.add(panel);

        this.frame.setSize(300, 200);
    }


    private String formatDate(Date seldate) {
        Calendar date = Calendar.getInstance();
        date.setTime(seldate);
        int month = date.get(Calendar.MONTH);
        int year = date.get(Calendar.YEAR);

        return new String(month + "/" + year);
    }

    public void stateChanged(ChangeEvent e) {
        Object obj = e.getSource();

        if (obj == this.numSpinner) {
            this.lmodel.addElement(this.nummodel.getNumber());

        } else if (obj == this.dateSpinner) {
            String nline = this.formatDate(this.datemodel.getDate());

            if (!last.equalsIgnoreCase(nline)) {
                this.lmodel.addElement(nline);
                this.last = nline;
            }
        }
    }



    public void display() {
        this.frame.setVisible(true);
    }


    public static void main(String args[]) {
        ListModelDemo demo = new ListModelDemo();
        demo.display();
    }
}
