/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 * Cours ISI5 / INF2 - Developpement d'Interface
 */

package review.ihmexamples.tempconverter;

/**
 * Temperature Converter keeps track of a given temperature in °C or °F
 * and supplies methods for converting from °C to °F and vice-versa
 * @author kirsch
 */
public class TemperatureConverter {
    private double temp;

    public TemperatureConverter(double temp) {
        this.temp = temp;
    }

    public double getTemp() {
        return temp;
    }

    public void setTemp(double temp) {
        this.temp = temp;
    }

    /**
     * Convert the temperature to Celcius by
     * considering the temperature originally as in °F.
     * @return double temperature in °C
     */
    public double toCelcius () {
        return ((this.temp-32)*5)/9;
    }

    /**
     * Convert the temperature to Fahrenheit by
     * considering the temperature originally as in °C.
     * @return double temperature in °F
     */
    public double toFahrenheit () {
        return (this.temp*9)/5 + 32;
    }

}
