/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 * Cours ISI5 / INF2 - Developpement d'Interface
 */
package review.ihmexamples.tempconverter;

import java.util.Scanner;
import java.util.InputMismatchException;

/**
 * Text Interface for reading and showing a temperature
 * @author kirsch
 */
public class TextInterface {
    
    /**
     * Read from the standard input a temperature
     * @param mesg message to be presented to the user before reading
     * @param error error message to be presented to the user if an input
     *        mismatch exception raises 
     * @return double temperature read (or 0 input couldn't be interpreted)
     * @see java.util.InputMismatchException
     */
    public double read(String mesg, String error) {
        Scanner in = new Scanner(System.in);
        double temp=0;

        System.out.print(mesg);
        try {
            temp = in.nextDouble();
        } catch (InputMismatchException ipe) {
            System.out.println(error);
        }

        return temp;
    }

    /**
     * Show in the standard output a message for the user and a given tempearture
     * @param mesg message to be presented to the user before the temperature
     * @param temp temperature to be presented to the user
     */
    public void show (String mesg, double temp) {
        System.out.printf("%s %.2f\n", mesg, temp);
    }
}
