/*
 * UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 * MIAGE - UFR 27
 * Cours ISI5 / INF2 - Developpement d'Interface
 */

package review.ihmexamples.tempconverter.converterawt;

/**
 * Temperature Converter keeps track of a given temperature in °C or °F
 * and supplies methods for converting from °C to °F and vice-versa
 * @author kirsch
 */

import java.awt.*;
import review.ihmexamples.tempconverter.*;


public class TempConverterAwtGUIv2 extends java.awt.Frame {

    private java.awt.Button optCelsius;
    private java.awt.Button optFahrenheit;
    private java.awt.Label resultat;
    private java.awt.Panel panel1;
    private java.awt.TextField textField1;


    /** Creates new form TempConverterAwtGUI */
    public TempConverterAwtGUIv2() {
        initComponents();
    }

    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        panel1 = new java.awt.Panel();
        panel1.setLayout(new java.awt.BorderLayout());

        textField1 = new java.awt.TextField();
        textField1.setText("");
        textField1.setColumns(10);


        optCelsius = new java.awt.Button();
        optCelsius.setLabel("Celsius");
        optFahrenheit = new java.awt.Button();
        optFahrenheit.setLabel("Fahrenheit");

        resultat = new java.awt.Label();
        resultat.setText("                 ");

        setLayout(new java.awt.GridBagLayout());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.gridy = 0;
        add(textField1, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 3;
        gridBagConstraints.gridy = 0;
        gridBagConstraints.ipadx = 40;
        add(resultat, gridBagConstraints);
        //add(resultat, new java.awt.GridBagConstraints());

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 0;
        add(optCelsius, gridBagConstraints);

        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 1;
        gridBagConstraints.gridy = 1;
        add(optFahrenheit, gridBagConstraints);

        //setMinimumSize(new Dimension(300,150));
        setSize(400,150);

        //pack();


         addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                exitForm(evt);
            }
        });


        optCelsius.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                optCelsiusActionPerformed(evt);
            }
        });

        optFahrenheit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                optFahrenheitActionPerformed(evt);
            }
        });

    }

    private void convert (boolean celsius){
        String stringTemp = textField1.getText();
        double result=0;

        try
        {
            double temp = new Double(stringTemp).doubleValue();

            TemperatureConverter tmpc = new TemperatureConverter(temp);

            if (celsius==true)
            {
                result = tmpc.toCelcius();
            }
            else
            {
                result = tmpc.toFahrenheit();
            }
            resultat.setText(Double.toString(result));
        }
        catch (NumberFormatException ex)
        {
            resultat.setText("valeur incorrecte");
        }
    }

    /** Exit the Application */
    private void exitForm(java.awt.event.WindowEvent evt) {
        System.exit(0);
    }

    private void optCelsiusActionPerformed(java.awt.event.ActionEvent evt) {
        convert(true);
    }

    private void optFahrenheitActionPerformed(java.awt.event.ActionEvent evt) {
        convert(false);
    }


    /**
    * @param args the command line arguments
    */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                TempConverterAwtGUIv2 TC = new TempConverterAwtGUIv2();
                TC.setVisible(true);
            }
        });
    }
}
