/*
 UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 MIAGE - UFR 27
 Cours ISI5 / INF2 - Developpement d'Interface

 */

package review.ihmexamples.volumeapplication;

import java.awt.BorderLayout;
import java.awt.Dimension;
import javax.swing.DefaultListModel;
import javax.swing.JFrame;
import javax.swing.JList;
import javax.swing.JScrollPane;
import javax.swing.ListModel;

/**
 * Example d'usage du modele MVC
 * Cette classe definit une vue basé sur une liste de valeurs
 * pour un modele de volume
 *
 * Example base sur Baptiste Wicht, <b>"Implémentation du pattern MVC"</b>,
 * 24 Avril 2007 (derniere visite le 29 Janvier 2009).
 * @see http://baptiste-wicht.developpez.com/tutoriel/conception/mvc/
 * @author kirsch
 */
public class VolumeListView extends VolumeView {

    public VolumeListView(VolumeController controller, int volume) {
        super(controller);
        this.buildFrame(volume);
    }

    public VolumeListView(VolumeController controller) {
        this(controller, 0);
    }

    private void buildFrame(int volume) {
        this.jFrame = new JFrame();
        jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

         /* on definit le layoutmanager avec 2x plus d'espace vert. et horiz. */
        BorderLayout border = new BorderLayout();
        border.setHgap(border.getHgap() * 2);
        border.setVgap(border.getVgap() * 2);
        jFrame.setLayout(border);


        jListModel = new DefaultListModel();
		jListModel.addElement(volume);

        jVolumeList = new JList (jListModel);

        JScrollPane scrollPane = new JScrollPane (jVolumeList);
        jFrame.add(scrollPane, BorderLayout.CENTER);

        jFrame.pack();
    }


    @Override
    public void display() {
        this.jFrame.setVisible(true);
    }

    @Override
    public void close() {
        this.jFrame.setVisible(false);
    }

    public void volumeChanged(VolumeChangedEvent event) {
		jListModel.addElement(event.getNewVolume());
    }

    @Override
    public void setLocation(int x, int y) {
        this.jFrame.setLocation(x, y);
    }

    @Override
    public void setSize(Dimension d) {
        this.jFrame.setSize(d);
    }

    @Override
    public Dimension getSize() {
        return this.jFrame.getSize();
    }


    JFrame jFrame;
    JList jVolumeList;
    DefaultListModel jListModel;
}
