/*
 UNIVERSITE PARIS 1 (PANTHEON SORBONNE)
 MIAGE - UFR 27
 Cours ISI5 / INF2 - Developpement d'Interface

 */

package review.ihmexamples.volumeapplication;

import java.awt.Dimension;
import java.awt.FlowLayout;
import javax.swing.JFrame;
import javax.swing.JProgressBar;
import javax.swing.SwingConstants;

/**
 * Example d'usage du modele MVC
 * Cette classe definit une vue basé sur une barre de progression qui
 * permet de visualiser la valeur du modele de volume
 *
 * @author kirsch
 */
public class VolumeProgressView extends VolumeView {
    private JFrame jFrame;
    private JProgressBar jProgress;


    public VolumeProgressView(VolumeController controller) {
        this(controller, 0);
    }

    public VolumeProgressView(VolumeController controller, int volume) {
        super(controller);
        this.buildFrame(volume);
    }



    private void buildFrame(int volume) {
        this.jFrame = new JFrame();
        jFrame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        jFrame.setLayout(new FlowLayout());

        jProgress = new JProgressBar (0, 100);
        jProgress.setOrientation(SwingConstants.VERTICAL);
        jProgress.setValue(volume);

        jFrame.add(jProgress);
        
        jFrame.pack();
    }


    @Override
    public void display() {
        this.jFrame.setVisible(true);
    }

    @Override
    public void close() {
        this.jFrame.setVisible(false);
    }

    @Override
    public void setLocation(int x, int y) {
        this.jFrame.setLocation(x, y);
    }

    @Override
    public void setSize(Dimension d) {
        this.jFrame.setSize(d);
    }

    @Override
    public Dimension getSize() {
        return this.jFrame.getSize();
    }


    public void volumeChanged(VolumeChangedEvent event) {
        this.jProgress.setValue(event.getNewVolume());
    }

}
