package review.mvc;

import java.util.ArrayList;
import java.util.List;


// <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
// #[regen=yes,id=DCE.52E3FA3C-AFCF-3848-B8D9-C818A96A948F]
// </editor-fold> 
public class ConcreteVolumeControler implements VolumeControler {

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.37BC3AA6-923D-51C2-1CDC-42DFE5A7C30F]
    // </editor-fold> 
    private VolumeModel model;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.54C4154B-1923-2AC0-B801-5E7461447C70]
    // </editor-fold> 
    private List<VolumeView> views;

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.AB4DDC19-94C1-AC73-7C09-95D88D75AEF4]
    // </editor-fold> 
    public ConcreteVolumeControler () {
        this(null);
    }

    public ConcreteVolumeControler (VolumeModel model) {
        this.model = model;
        this.views = (List) new ArrayList<VolumeView>();
    }

    
    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.6F627D29-C78C-E66F-81A7-2D929BB6EF40]
    // </editor-fold> 
    public void setVolumeModel (VolumeModel model) {
        this.model = model;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.98503D9B-81E9-FBAF-7552-76451820E728]
    // </editor-fold> 
    public VolumeModel getVolumeModel () {
        return this.model;
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.8DD403CC-E7B2-1CAE-4AD8-CA5A0E2A7258]
    // </editor-fold> 
    public void notifyVolumeChange (int newVal) {
        this.model.setVolume(newVal);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.22D3D08D-3D78-F3DC-3977-BCE07209F79A]
    // </editor-fold> 
    public void addView (VolumeView view) {
        this.views.add(view);
        this.model.addVolumeListener(view);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,id=DCE.E7CD355C-38F2-A9DE-2CA1-9A00FAA083FB]
    // </editor-fold> 
    public void removeVolumeView (VolumeView view) {
        this.model.removeVolumeListener(view);
        this.views.remove(view);
    }

    // <editor-fold defaultstate="collapsed" desc=" UML Marker "> 
    // #[regen=yes,regenBody=yes,id=DCE.F01FD6C6-266F-449C-BFFE-7643EA375DE9]
    // </editor-fold> 
    public VolumeModel getModel () {
        return model;
    }

     public void displayViews() {
        for (VolumeView aView: this.views) {
            aView.display();
        }
     }

    public void closeViews() {
        for (VolumeView aView: this.views) {
            System.exit(0);
        }
    }
}

